/* ClsTypes.h */

#ifndef __ClsTypes_h
#define __ClsTypes_h

#include <limits.h>

#include "ClsDefs.h"

typedef unsigned int classType;

enum
  {
    // From ClassLib
    stringClass,
    clArrayClass,
    srtArrayClass,

    // Trees
    treeClass,
    bioTreeClass,
    geneTreeClass,
    speciesTreeClass,
    treeInjectionClass,
    duplicationsTreeClass,
    nucleotideTreeClass,

    // Settings
    settingsClass,
    realSettingClass,
    integerSettingClass,
    stringSettingClass,
    booleanSettingClass,

    // Misc.
    geneClass,
    intMatrixClass,
    errorMessageClass,
    speciesTreesArrayClass,
    spTreesArrayElementClass,

    __lastLibClass = 0xff,
    __firstUserClass,
    __lastClass = UINT_MAX
  };

#endif // __ClsTypes_h

