/* Object.h */

#ifndef __Object_h
#define __Object_h

#include <stddef.h>
#include <iostream>

using namespace std;

#include "ClsDefs.h"
#include "ClsTypes.h"

_CLASSDEF(Object)

abstract class Object
  {

  public:

    virtual ~Object() {}

    virtual classType   isA     ()              const = 0;
    virtual const char* nameOf  ()              const = 0;
    virtual bool        isEqual ( RCObject o  ) const { return this==&o; }
    virtual void        printOn ( ostream& os ) const { os << nameOf(); }

    virtual bool isClonable () const { return false; }
    virtual bool isSortable () const { return false; }

  };

inline ostream& operator << ( ostream& os, RCObject o )
  { o.printOn(os); return os; }

inline int operator == ( RCObject o1, RCObject o2 )
  { return ( &o1==&o2 || o1.isA()==o2.isA() && o1.isEqual(o2) ); }

inline int operator != ( RCObject o1, RCObject o2 )
  { return !( o1==o2 ); }

#endif  // __Object_h

