/* SpecTree.cpp */
/*
()
() **************************************************************************
() * -inline   SpeciesTree                                    *
() **************************************************************************
()
*/

#include "SpecTree.h"

/*
()       : hasSpecies( String specName )  ( );
()    : ,        . ;
()   :  () ;
()  : true/false ( /  ).
()
*/
bool SpeciesTree::hasSpecies( RCString specName ) const
  {
    if ( isLeaf() )
      return (name()==specName);
    else
      for ( uint n=0; n<numberOfChildren(); n++ )
        if ( child(n).hasSpecies(specName) )
          return true;

    return false;
  }

/*
()       : species()  ();
()    :     ;
()   :  ;
()  :   .
()
*/
RCSpeciesTree SpeciesTree::species( RCString speciesName ) const
  {
    if ( isLeaf() )
      return ( (name()==speciesName) ? ME : RCSpeciesTree(nullTree) );

    PCSpeciesTree s;
    for ( uint n=0; n<numberOfChildren(); n++ )
      if ( (s=&child(n).species(speciesName)) != &nullTree )
        return *s;

    return RCSpeciesTree(nullTree);
  }


