/* TParser.h */

#ifndef __TPARSER_H
#define __TPARSER_H

#include <fstream>

using namespace std;

#include "Parser.h"

#include "LexYY.h"
#include "TreeMan.h"
#include "GeneTree.h"
#include "SpecTree.h"

_CLASSDEF(TreeParser)

class TreeParser : public TParser, public yyFlexLexer
  {

  public:

    TreeParser( istream& inputStream=cin, RCString fileName="" ) :
      TParser( fileName ),
      yyFlexLexer( &inputStream )
      {}

    int getSpeciesTrees ( RClArray c ) { container = &c; return xxparse(); }
    int getGeneTrees    ( RClArray c ) { container = &c; return yyparse(); }

  private:

    //       
    unsigned line() { return yycurline(); }
    int      xxparse();
    int      yyparse();

    PClArray container;

  };

#endif // __TPARSER_H

